function vystup_I = mozaika(I,tile_x, tile_y)
%MOZAIKA Funkce, ktera vykresli mozaiku

[m,n,o] = size(I);
pocet_x = floor(m/tile_x);
pocet_y = floor(n/tile_y);

I = I(1:pocet_x*tile_x, 1:pocet_y*tile_y,:);
num = 32;
prumerna_barva = zeros([32,3]);

vystup_I = I;

for i = 1 : 32
    J = imread(strcat('photo/', string(i), '.jpg'));
    C{i} = imresize(J, [tile_x,tile_y]);
    barva = imresize(J, [1,1],'bicubic');
    prumerna_barva(i,1)=barva(1,1,1); 
    prumerna_barva(i,2)=barva(1,1,2); 
    prumerna_barva(i,3)=barva(1,1,3); 
end

pom_I = imresize(I,[pocet_x,pocet_y],'bicubic');

for i = 1 : pocet_x
    for j = 1 : pocet_y
        % nalezeni nejblizsi barvy
        index = nejblizsi(pom_I(i,j,:), prumerna_barva,num);
        vystup_I((i-1)*tile_x + 1 : (i-1)*tile_x + tile_x, (j-1)*tile_y + 1 : (j-1)*tile_y + tile_y,:) = C{index};
    end
end

end


function [index] = nejblizsi(barva, pole, pocet)
    vzdalenosti = zeros([1,pocet]);
    barva = double(barva);
    pole = double(pole);
    for i = 1 : pocet
        vzdalenosti(i) = sqrt((barva(1,1,1)-pole(i,1))^2+(barva(1,1,2)-pole(i,2))^2+(barva(1,1,3)-pole(i,3))^2);
    end
    [~,index] = min(vzdalenosti);
end
